#******************************************************
# Place a metacloud sphere at the position of each
#  object selected when the script is run
# 
# - cloudbuilder.py
# - By Mark Caldwell
# - Version 0.1
# - 25th February 2007
# - Tested with Vue 6 Infinite and Vue 7 Infinite
#
# How to use in 3 easy steps
#
# 1. Download this file onto your computer
#
# 2. Select some objects
#
# 3. Then run script and wait for it to work
#    To run it go to Python -> Run Python Script
#    Then locate the file on your computer
#
#******************************************************

#----------------------------------------------
# Configuration: Set these to alter end result
#----------------------------------------------

scale_factor=0.01        # Apply this to cloud sphere size may need to vary this to get a good match to objects selected

#--------------------------------------------------------------------------
# Test the user has a scene loaded
#--------------------------------------------------------------------------

if TestLoaded(): 

#--------------------------------------------------------------------------
# Test to make sure the user has at least 1 object selected
#--------------------------------------------------------------------------

    numselected=CountSelectedObjects()

    if numselected>0:

#--------------------------------------------------------------------------
#Set Up a Few Variables and load clouds
#--------------------------------------------------------------------------

        objects=[]
        clouds=[]

#--------------------------------------------------------------------------
# Get list of selected objects
#--------------------------------------------------------------------------

        for i in range (0,numselected):
            objecta=GetSelectedObjectByIndex(i)
            objects.append(objecta)

#--------------------------------------------------------------------------
# Create Clouds
#--------------------------------------------------------------------------

        cloud=ImportObject ('cloud1.vob')
        clouds.append(cloud)

        for i in range (1,numselected):
            SelectOnly(cloud)
            Duplicate()
            objecta=GetSelectedObjectByIndex(0) 
            clouds.append(objecta)

#--------------------------------------------------------------------------
# Put Clouds in same place as selected objects
#--------------------------------------------------------------------------

        for i in range(0,numselected):
            objecta=objects[i]
            pos=objecta.Position ()                      # Get instance position
            sca=objecta.GetScale()                       # Get instance scale
            cloudobject=clouds[i]
            cloudgroup=cloudobject.ToGroup()
            sphere=cloudgroup.Member(0)
            sphere.SetPosition(pos[0],pos[1],pos[2])                    # Set object's position
            sphere.ResizeAxis(scale_factor,scale_factor,scale_factor)   # Set cloud object's size so they match a cubes
            sphere.ResizeAxis(sca[0],sca[1],sca[2])                     # Set object's size

#--------------------------------------------------------------------------
# Put cloud spheres in a group and name them
#--------------------------------------------------------------------------

        DeselectAll()
        for i in range (0,numselected):
            Select(clouds[i])
        group=Group ()
        group.SetName ('Cloud Group')
        DeselectAll()

#--------------------------------------------------------------------------
# Select the originally selected objects
#--------------------------------------------------------------------------

        for i in range (0,numselected):
            Select(objects[i])

#--------------------------------------------------------------------------
# Display messages for success or failure of Cloud Builder
#--------------------------------------------------------------------------        

    message="Cloud Builder Successful"
else:
    message="No Scene Loaded"
                    
Message(message)    # Display message

Refresh()
       
#--------------------------------------------------------------------------
# End of Script
#--------------------------------------------------------------------------
                



    
                









    
 

